#!/usr/bin/env python

from bisect import bisect_left, insort_left

# Time management.

def insert_period(freebusy, period):
    insort_left(freebusy, period)

def remove_period(freebusy, uid):
    i = 0
    while i < len(freebusy):
        t = freebusy[i]
        if len(t) >= 3 and t[2] == uid:
            del freebusy[i]
        else:
            i += 1

def period_overlaps(freebusy, period):
    dtstart, dtend = period[:2]
    i = bisect_left(freebusy, (dtstart, dtend, None))
    return (
        i < len(freebusy) and (dtend is None or freebusy[i][0] < dtend)
        or
        i > 0 and freebusy[i - 1][1] > dtstart
        )

# vim: tabstop=4 expandtab shiftwidth=4
